/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2011 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.fwkcktlajaxwebext.serveur.component;

import java.util.Enumeration;

import com.webobjects.appserver.WOActionResults;
import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WOElement;
import com.webobjects.appserver.WORequest;
import com.webobjects.appserver.WOResponse;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSMutableArray;
import com.webobjects.foundation.NSMutableDictionary;

import er.ajax.AjaxAutoComplete;
import er.ajax.AjaxOption;
import er.ajax.AjaxUpdateContainer;
import er.ajax.AjaxUtils;
import er.ajax.CktlAjaxUtils;
import er.extensions.components.ERXClickToOpenSupport;

// Generated by the WOLips Templateengine Plug-in at 12 mars 2008 11:24:48
public class CktlAjaxAutoComplete extends AjaxAutoComplete {
	public Object selection = null;

    public static final boolean isClickToOpenEnabled = Boolean.valueOf(System.getProperty("er.component.clickToOpen", "false"));
	private String cssClass;
	private String cssStyle;


	public CktlAjaxAutoComplete(WOContext context) {
		super(context);
	}

	@Override
    public void appendToResponse(WOResponse woresponse, WOContext wocontext) {
        ERXClickToOpenSupport.preProcessResponse(woresponse, wocontext, isClickToOpenEnabled);
        super.appendToResponse(woresponse, wocontext);
        ERXClickToOpenSupport.postProcessResponse(getClass(), woresponse, wocontext, isClickToOpenEnabled);
	}
	
	@Override
	public void reset() {
		selection = null;
		super.reset();
	}
	
	// In an horizontal wizard case representation, you must not clone the left position
	@Override
	protected NSDictionary createAjaxOptions() {
		NSMutableArray ajaxOptionsArray = new NSMutableArray();
		ajaxOptionsArray.addObject(new AjaxOption("tokens", AjaxOption.STRING_ARRAY));
		ajaxOptionsArray.addObject(new AjaxOption("frequency", AjaxOption.NUMBER));
		ajaxOptionsArray.addObject(new AjaxOption("minChars", AjaxOption.NUMBER));
		ajaxOptionsArray.addObject(new AjaxOption("indicator", AjaxOption.SCRIPT));
		ajaxOptionsArray.addObject(new AjaxOption("updateElement", AjaxOption.SCRIPT));
		ajaxOptionsArray.addObject(new AjaxOption("afterUpdateElement", AjaxOption.SCRIPT));
		ajaxOptionsArray.addObject(new AjaxOption("onComplete", AjaxOption.SCRIPT));
		ajaxOptionsArray.addObject(new AjaxOption("fullSearch", AjaxOption.BOOLEAN));
		ajaxOptionsArray.addObject(new AjaxOption("partialSearch", AjaxOption.BOOLEAN));
		ajaxOptionsArray.addObject(new AjaxOption("defaultValue", AjaxOption.STRING));
		ajaxOptionsArray.addObject(new AjaxOption("autoSelect", AjaxOption.BOOLEAN));
		ajaxOptionsArray.addObject(new AjaxOption("choices", AjaxOption.NUMBER));
		ajaxOptionsArray.addObject(new AjaxOption("partialChars", AjaxOption.NUMBER));
		ajaxOptionsArray.addObject(new AjaxOption("ignoreCase", AjaxOption.BOOLEAN));
		NSMutableDictionary options = AjaxOption.createAjaxOptionsDictionary(ajaxOptionsArray, this);
		Boolean autoWidth = Boolean.FALSE;
		if (hasBinding("autoWidth")) {
			autoWidth = (Boolean) valueForBinding("autoWidth");
		}
		String onShow = "function(element, update) { if(!update.style.position || update.style.position=='absolute') {update.style.position = 'absolute';var isSetLeft=true;if (Prototype.Browser.Gecko) {isSetLeft=false;} Position.clone(element, update, {setLeft: isSetLeft, setHeight: false"
				+ (autoWidth.booleanValue() ? "" : ", setWidth: false") + ", offsetTop: element.offsetHeight});} update.style.zIndex=99999; Effect.Appear(update,{duration:0.15});}";
		options.setObjectForKey(onShow, "onShow");
		if (hasBinding("classSearchIndicator")) {
			options.setObjectForKey("'" + (String) valueForBinding("classSearchIndicator") + "'", "classSearchIndicator");
		}
		else {
			options.setObjectForKey("'autocompletefield_busy'", "classSearchIndicator");
		}
		if (hasBinding("updateContainerId")) {
			options.setObjectForKey("'" + (String) valueForBinding("updateContainerId") + "'", "updateContainerId");
		}
		if (hasBinding("updateContainerID")) {
			options.setObjectForKey("'" + (String) valueForBinding("updateContainerID") + "'", "updateContainerID");
		}
		return options;
	}

	/**
	 * Adds all required resources.
	 */
	@Override
	protected void addRequiredWebResources(WOResponse response) {
		boolean isDisabled = hasBinding("disabled") && (Boolean) valueForBinding("disabled") != null && ((Boolean) valueForBinding("disabled")).booleanValue();
		if (!isDisabled) {
			CktlAjaxUtils.addScriptResourceInHead(context(), response, "prototype.js");
			CktlAjaxUtils.addScriptResourceInHead(context(), response, "effects.js");
			CktlAjaxUtils.addScriptResourceInHead(context(), response, "controls.js");
			CktlAjaxUtils.addScriptResourceInHead(context(), response, "wonder.js");
			CktlAjaxUtils.addScriptResourceInHead(context(), response, "FwkCktlAjaxWebExt.framework", "scripts/cktlwonder.js");
			// Resource with override selectEntry() method to push the selection object
			CktlAjaxUtils.addScriptResourceInHead(context(), response, "FwkCktlAjaxWebExt.framework", "scripts/cocktailajaxautocomplete.js");
			//CktlAjaxUtils.addStylesheetResourceInHead(context(), res, frameworkName(), "css/CocktailAjaxAutoComplete.css");
		}
	}

	/**
	 * Handles the Ajax request. Checks for the form value 'selectIndex' passed in parameter of url If present and binding selection exist, push the
	 * selected object up to the parent If selectedIndex is null or selection binding not present Checks for the form value in the edit field, pushes
	 * it up to the parent and pulls the "list" binding. The parent is responsible for returning a list with some items that match the current value.
	 */
	@Override
	public WOActionResults handleRequest(WORequest request, WOContext context) {
		WOResponse response = null;

		String fieldValue = context.request().stringFormValueForKey(fieldName);
		String selectedIndex = context.request().stringFormValueForKey("selectedIndex");

		boolean hasSelectionBinding = hasBinding("selection");

		if (hasSelectionBinding && selectedIndex != null) {
			int index = Integer.valueOf(selectedIndex).intValue();

			if (hasBinding("updateContainerId")) {
				WOComponent component = context.component();
				String updateContainerID = (String) valueForBinding("updateContainerId");
				AjaxUpdateContainer.setUpdateContainerID(request, updateContainerID);
			}
			if (hasBinding("updateContainerID")) {
				WOComponent component = context.component();
				String updateContainerID = (String) valueForBinding("updateContainerID");
				AjaxUpdateContainer.setUpdateContainerID(request, updateContainerID);
			}

			if (index > -1) {
				NSArray values = (NSArray) valueForBinding("list");
				setValueForBinding(fieldValue, "value");
				Object selection = null;
				if (values != null && values.count() > 0 && index < values.count()) {
					selection = values.objectAtIndex(index);
					setValueForBinding(selection, "selection");
				}
				setValueForBinding(selection, "item");
			}
			else {
				setValueForBinding(fieldValue, "value");
				setValueForBinding(null, "selection");
			}
		}
		else {
			setValueForBinding(fieldValue, "value");
			NSArray values = (NSArray) valueForBinding("list");
			WOElement child = _childTemplate();
			boolean hasItem = hasBinding("item");
			response = AjaxUtils.createResponse(request, context);

			int maxItems = ((Integer) valueForBinding("maxItems", new Integer(50))).intValue();
			int itemsCount = 0;
			if (values != null) {
				response.appendContentString("<ul>");
				for (Enumeration e = values.objectEnumerator(); e.hasMoreElements() && itemsCount++ < maxItems;) {
					response.appendContentString("<li>");
					Object value = e.nextElement();
					if (hasItem && child != null) {
						setValueForBinding(value, "item");
						context._setCurrentComponent(parent());
						child.appendToResponse(response, context);
						context._setCurrentComponent(this);
					}
					else {
						if (hasItem) {
							setValueForBinding(value, "item");
						}
						Object displayValue = valueForBinding("displayString", valueForBinding("item", value));
						String displayString = displayValue.toString();
						response.appendContentString(displayString);
					}
					response.appendContentString("</li>");
					//setValueForBinding(values.objectAtIndex(0), "selection");
				}
				response.appendContentString("</ul>");
			}

		}

		return response;
	}

	public Object getSelection() {
		return selection;
	}

	public void setSelection(Object selection) {
		this.selection = selection;
	}

	/**
	 * @return the cssClass
	 */
	public String cssClass() {
		cssClass = (String) valueForBinding("class");
		if (cssClass == null) {
			cssClass = "autocompletefield";
		}
		return cssClass;
	}

	/**
	 * @param cssClass the cssClass to set
	 */
	public void setCssClass(String cssClass) {
		this.cssClass = cssClass;
	}

	/**
	 * @return the cssStyle
	 */
	public String cssStyle() {
		cssStyle = (String) valueForBinding("style");
		return cssStyle;
	}

	/**
	 * @param cssStyle the cssStyle to set
	 */
	public void setCssStyle(String cssStyle) {
		this.cssStyle = cssStyle;
	}

	public String containerElementName() {
		if(hasBinding("containerElementName")) {
			return (String) valueForBinding("containerElementName");
		}
		return "div";
	}
	
}
